# MiCoNE - Microbial Co-occurrence Network Explorer

![Build Status](https://github.com/segrelab/MiCoNE/workflows/build/badge.svg)
[![Documentation Status](https://readthedocs.org/projects/micone/badge/?version=latest)](https://micone.readthedocs.io/en/latest/?badge=latest)
[![codecov](https://codecov.io/gh/segrelab/MiCoNE/branch/master/graph/badge.svg?token=2tKiI0lUJb)](https://codecov.io/gh/segrelab/MiCoNE)
[![CodeFactor](https://www.codefactor.io/repository/github/segrelab/micone/badge)](https://www.codefactor.io/repository/github/segrelab/micone)
[![Updates](https://pyup.io/repos/github/segrelab/MiCoNE/shield.svg)](https://pyup.io/repos/github/segrelab/MiCoNE/)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/ambv/black)

`MiCoNE` is a Python package for the exploration of the effects of various possible tools used during the 16S data processing workflow on the inferred co-occurrence networks.
It is also developed as a flexible and modular pipeline for 16S data analysis, offering parallelized, fast and reproducible runs executed for different combinations of tools for each step of the data processing workflow.
It incorporates various popular, publicly available tools as well as custom Python modules and scripts to facilitate inference of co-occurrence networks from 16S data.

- Free software: MIT license
- Documentation: <https://micone.readthedocs.io/>

Manuscript can be found on [bioRxiv](https://www.biorxiv.org/content/10.1101/2020.09.23.309781v2) (to be updated with link to publication).

## Features

- Plug and play architecture: allows easy additions and removal of new tools
- Flexible and portable: allows running the pipeline on local machine, compute cluster or the cloud with minimal configuration change through the usage of [nextflow](www.nextflow.io)
- Parallelization: automatic parallelization both within and across samples (needs to be enabled in the `nextflow.config` file)
- Ease of use: available as a minimal `Python` library (without the pipeline) or as a full `conda` package

## Installation

Installing the minimal `Python` library:

```sh
pip install micone
```

Installing the `conda` package:

```sh
git clone https://github.com/segrelab/MiCoNE.git
cd MiCoNE
# Here we use mamba, you can also use conda
mamba env create -n micone -f env.yml
```

> NOTE:
> Direct installation via anaconda cloud will be available soon.


## Workflow

![pipeline](assets/pipeline.png)

It supports the conversion of raw 16S sequence data into co-occurrence networks.
Each process in the pipeline supports alternate tools for performing the same task, users can use the configuration file to change these values.

## Usage (needs to be updated)

The `MiCoNE` pipelines comes with an easy-to-use CLI. To get a list of subcommands you can type:

```bash
micone --help
```

Supported subcommands:

1. `init` - Creates `conda` environments for various pipeline processes
2. `run` - The main subcommand that runs the pipeline
3. `clean` - Cleans temporary data, log files and other extraneous files

To run the pipeline:

```bash
micone run -p local -c run.toml -m 4
```

This runs the pipeline in the `local` machine using `run.toml` for the pipeline configuration and with a maximum of 4 processes in parallel at a time.

## Configuration (needs to be updated)

The configuration of the pipeline can be done using a `.toml` file.
The details can be found in the relevant section in the docs.
Here is an example `config` file that performs:

1. grouping of OTUs by taxonomy level
2. correlation of the taxa using `fastspar`
3. calculates p-values
4. constructs the networks

```sh
Coming soon
```

Other example `config` files can be found at `tests/data/pipelines`

## Credits

This package was created with [Cookiecutter](https://github.com/audreyr/cookiecutter) and the [audreyr/cookiecutter-pypackage](https://github.com/audreyr/cookiecutter-pypackage) project template.

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

big.data <- ${big_data}
multithread <- ${ncpus}

# Load file names and sample names from manifest file
manifest <- read.csv("MANIFEST", comment.char="#")
reads <- sapply(as.character(manifest\$absolute.filepath), basename)
sample.names <- as.character(manifest\$sample.id)
names(reads) <- sample.names

# Denoising
if(big.data) {
    reads.err <- learnErrors(reads, nbases=1e8, multithread=multithread,  randomize=TRUE)
    reads.dada <- vector("list", length(sample.names))
    names(reads.dada) <- sample.names
    for(sample in sample.names) {
        cat("Processing:", sample, "\\n")
        read.derep <- derepFastq(reads[[sample]])
        reads.dada[[sample]] <- dada(read.derep, err=reads.err, multithread=multithread)
    }
} else {
    reads.err <- learnErrors(reads, multithread=multithread)
    reads.derep <- derepFastq(reads)
    reads.dada <- dada(reads.derep, err=reads.err, multithread=multithread)
}

seq.table <- makeSequenceTable(reads.dada)
rownames(seq.table) <- sample.names

write.table(t(seq.table), file="seq_table.tsv", col.names=NA, sep="\\t")

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

big.data <- ${big_data}
multithread <- ${ncpus}

# get files
filts <- sort(list.files(".", pattern="fastq.gz\$", full.names=TRUE))
# Extract sample names, assuming filenames have format: SAMPLENAME_XXX.fastq
sample.file.names <- sapply(strsplit(basename(filts), "_"), `[`, 1)


manifest <- read.csv("MANIFEST", header=TRUE, comment.char='#')
sample.names <- sort(unique(manifest\$sample.id))
names(filts) <- sample.names


# Denoising
if(big.data) {
    err <- learnErrors(filts, nbases = 1e8, multithread=multithread, randomize=TRUE)
    # Infer sequence variants
    dds <- vector("list", length(sample.names))
    names(dds) <- sample.names
    for(sam in sample.names) {
        cat("Processing:", sam, "\n")
        derep <- derepFastq(filts[[sam]])
        dds[[sam]] <- dada(derep, err=err, multithread=multithread)
    }
} else {
    # get error rates
    err <- learnErrors(filts, multithread=multithread)
    # NOTE: This now supports filepaths directly (no need to derep)
    # apply the dada2 algorithm
    dds <- dada(filts, err=err, multithread=multithread)
}

seq.table <- makeSequenceTable(dds)
rownames(seq.table) <- sample.names

write.table(t(seq.table), file="seq_table.tsv", col.names=NA, sep="\\t")

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

big.data <- ${big_data}
multithread <- ${ncpus}

# get files
# Forward and reverse fastq filenames have format: SAMPLENAME_R1_001.fastq and SAMPLENAME_R2_001.fastq
filtFs <- sort(list.files(".", pattern="_R1_001.fastq.gz\$", full.names=TRUE))
filtRs <- sort(list.files(".", pattern="_R2_001.fastq.gz\$", full.names=TRUE))
# Extract sample names, assuming filenames have format: SAMPLENAME_XXX.fastq
sample.file.names <- sapply(strsplit(basename(filtFs), "_"), `[`, 1)
sample.file.namesR <- sapply(strsplit(basename(filtRs), "_"), `[`, 1)

if(!identical(sample.file.names, sample.file.namesR)) stop("Forward and reverse files do not match.")

manifest <- read.csv("MANIFEST", header=TRUE, comment.char='#')
sample.names <- sort(unique(manifest\$sample.id))

names(filtFs) <- sample.names
names(filtRs) <- sample.names


# Denoising
if(big.data) {
    # Learn forward error rates
    errF <- learnErrors(filtFs, nbases=1e8, multithread=multithread)
    # Learn reverse error rates
    errR <- learnErrors(filtRs, nbases=1e8, multithread=multithread)
    # Sample inference and merger of paired-end reads
    mergers <- vector("list", length(sample.names))
    names(mergers) <- sample.names
    for(sam in sample.names) {
        cat("Processing:", sam, "\n")
        derepF <- derepFastq(filtFs[[sam]])
        ddF <- dada(derepF, err=errF, multithread=multithread)
        derepR <- derepFastq(filtRs[[sam]])
        ddR <- dada(derepR, err=errR, multithread=multithread)
        merger <- mergePairs(ddF, derepF, ddR, derepR)
        mergers[[sam]] <- merger
    }
    rm(derepF); rm(derepR)
} else {
    # get error rates
    errF <- learnErrors(filtFs, multithread=multithread)
    errR <- learnErrors(filtRs, multithread=multithread)
    # NOTE: This now supports filepaths directly (no need to derep)
    # apply the dada2 algorithm
    dadaFs <- dada(filtFs, err=errF, multithread=multithread)
    dadaRs <- dada(filtRs, err=errR, multithread=multithread)
    # merge paired reads
    mergers <- mergePairs(dadaFs, filtFs, dadaRs, filtRs, verbose=TRUE)
}

seq.table <- makeSequenceTable(mergers)
rownames(seq.table) <- sample.names

write.table(t(seq.table), file="seq_table.tsv", col.names=NA, sep="\\t")

#!/usr/bin/env julia

using Distributed
addprocs(${ncpus})

@everywhere using FlashWeave

using CSV
using DataFrames
metadata_path = "fmt-control-Family_sample_metadata.tsv"

# data
data_path = "${otu_file}"
new_data_path = "${otu_file.baseName}.tsv"
if data_path != new_data_path
    cp(data_path, new_data_path, force=true, follow_symlinks=true)
end
metadata_path = "${sample_metadata}"
# NOTE: Transposing directly here does not work if the column names are long
metadata = CSV.read(metadata_path, DataFrame)
metadata_transpose = DataFrame(
    [[names(metadata)]; collect.(eachrow(metadata))], [:column; Symbol.(axes(metadata, 1))]
)
new_metadata_path = "${sample_metadata.baseName}_transposed.tsv"
CSV.write(new_metadata_path, metadata_transpose; writeheader=false, delim="\\t")

# options
sensitive = ${sensitive}
heterogeneous = ${heterogeneous}
FDR = ${fdr_correction}

netw_results = learn_network(
new_data_path,
new_metadata_path,
sensitive=sensitive,
heterogeneous=heterogeneous,
FDR=FDR,
transposed=true,
)

# You need to use networkx to export the .gml to table
output_file = "${meta.id}_network.gml"
save_network(output_file, netw_results)

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

chimera.method <- "${chimera_method}"
multithread <- as.integer("${ncpus}")

# load table and convert to matrix
seq.table.file <- "${seqtable_file}"
seq.table <- read.csv(seq.table.file, sep = "\\t", check.names = FALSE)
rownames(seq.table) <- seq.table[, 1]
seq.table <- seq.table[-c(1)]
seq.mat <- data.matrix(seq.table)
mode(seq.mat) <- "integer"

# chimera removal
seq.table.nochim <- removeBimeraDenovo(t(seq.mat), method = chimera.method, multithread = multithread, verbose = TRUE)

# Export sequences
uniquesToFasta(
  getUniques(seq.table.nochim),
  fout = "unhashed_rep_seqs.fasta",
  ids = paste0("Seq", seq(length(getUniques(seq.table.nochim))))
)
write.table(t(seq.table.nochim), file = "seq_table_nochim.tsv", col.names = NA, sep = "\\t", quote = FALSE)

# Export to biom
system("biom convert -i seq_table_nochim.tsv -o unhashed_otu_table.biom --to-hdf5")

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

multithread <- ${ncpus}
maxEE <- ${max_ee}
truncQ <- ${trunc_q}
trim_cmd <- "${trim_cmd}"

untrimmed.reads <- list.files(".", pattern=".fastq.gz\$", full.names=TRUE)

  if(length(untrimmed.reads) == 0) {
    errQuit("No input files with the expected filename format found.")
  }

# read trim and filter commands
trim.cmd <- read.csv(trim_cmd, header=FALSE)
trimLeft <- trim.cmd[1,2]
truncLen <- trim.cmd[2,2]


# trim sequences
trimmed.reads <- file.path("trimmed", basename(untrimmed.reads))
out <- suppressWarnings(
    filterAndTrim(
        untrimmed.reads,
        trimmed.reads,
        truncLen=truncLen,
        trimLeft=trimLeft,
        maxEE=maxEE,
        truncQ=truncQ,
        rm.phix=TRUE,
        multithread=multithread
    )
)

# check trimmed reads
cat(ifelse(file.exists(trimmed.reads), ".", "x"), sep="")
trimmed.reads <- list.files("trimmed", pattern=".fastq.gz\$", full.names=TRUE)
cat("\n")
if(length(trimmed.reads) == 0) { # All reads were filtered out
  errQuit("No reads passed the filter (was truncLen longer than the read length?)", status=2)
}

file.copy("MANIFEST", "trimmed")

#!/usr/bin/env Rscript

library(SPRING)

otu_file <- "${otu_file}"
corr_file <- "${meta.id}_corr.tsv"
nlambda <- as.double("${nlambda}")
lambda.min.ratio <- as.double("${lambda_min_ratio}")
ncpus <- as.integer("${ncpus}")

read_otu_data <- function(tablefile) {
  table <- read.table(tablefile, header = TRUE, check.names = FALSE, comment.char = "", sep = "\\t")
  table.rownames <- table[, 1]
  table <- table[, 2:ncol(table)]
  table.matrix <- data.matrix(table)
  rownames(table.matrix) <- table.rownames
  mode(table.matrix) <- "integer"
  return(table.matrix)
}

otu <- read_otu_data(otu_file)
otu_t <- t(otu)

# Apply SPRING on QMP data.
fit.spring <- SPRING(otu_t,
  nlambda = nlambda,
  lambda.min.ratio = lambda.min.ratio,
  ncores = ncpus,
  Rmethod = "approx",
  quantitative = FALSE,
  lambdaseq = "data-specific",
  rep.num = 50,
  verbose = TRUE
)

# StARS-selected lambda index based on the threshold (default = 0.01)
opt.K <- fit.spring\$output\$stars\$opt.index
# Estimated adjacency matrix from sparse graphical modeling technique ("mb" method) (1 = edge, 0 = no edge)
adj.K <- as.matrix(fit.spring\$fit\$est\$path[[opt.K]])
# Estimated partial correlation coefficient, same as negative precision matrix.
pcor.K <- as.matrix(SpiecEasi::symBeta(fit.spring\$output\$est\$beta[[opt.K]], mode = "maxabs"))

# In case of incorrect convergence
pcor.K[pcor.K > 1] = 1
pcor.K[pcor.K < -1] = -1

otuNetwork <- pcor.K
rownames(otuNetwork) <- rownames(otu)
colnames(otuNetwork) <- rownames(otu)
write.table(otuNetwork, file = corr_file, quote = FALSE, col.names = NA, sep = "\\t")

#!/usr/bin/env Rscript

library(SpiecEasi)
library(Matrix)

otu_file <- "${otu_file}"
method <- "${method}"
rep.num <- as.integer("${nreps}")
ncpus <- as.integer("${ncpus}")
nlambda <- as.double("${nlambda}")
lambda.min.ratio <- as.double("${lambda_min_ratio}")
corr_file <- "${meta.id}_corr.tsv"

# NOTE: The data does not have to be normalized
# Read in the OTU table
read_otu <- function(otufile) {
  otu <- read.table(otufile, header = TRUE, comment.char = "", check.names = FALSE, sep = "\\t")
  rownames(otu) <- otu[, 1]
  otu <- otu[, 2:ncol(otu)]
  return(otu)
}

# NOTE: You have to transpose the otu_data
# Calculate correlations using SpiecEasi
run_spieceasi <- function(otu_data, method = "mb", rep.num = 50, ncores = 4, nlambda = 20, lambda.min.ratio = 1e-2) {
  otu_ids <- rownames(otu_data)
  otu.spieceasi <- spiec.easi(
    t(otu_data),
    method = method,
    lambda.min.ratio = lambda.min.ratio,
    nlambda = nlambda,
    pulsar.params = list(rep.num = rep.num, ncores = ncores)
  )
  if (method == "mb") {
    sebeta <- symBeta(getOptBeta(otu.spieceasi), mode = "maxabs")
    mat <- as.matrix(sebeta)
  } else if (method == "glasso") {
    secor <- cov2cor(getOptCov(otu.spieceasi))
    mat <- as.matrix(secor * getRefit(otu.spieceasi))
  }
  matdims <- rep(list(otu_ids), 2)
  dimnames(mat) <- matdims
  return(mat)
}


# Actual script
otu_data <- read_otu(otu_file)
spieceasi.corr <- run_spieceasi(
  otu_data,
  method = method,
  rep.num = rep.num,
  ncores = ncpus,
  nlambda = nlambda,
  lambda.min.ratio = lambda.min.ratio
)

# In case of incorrect convergence
spieceasi.corr[spieceasi.corr > 1] <- 1
spieceasi.corr[spieceasi.corr < -1] <- -1

write.table(spieceasi.corr, file = corr_file, sep = "\\t", quote = FALSE, col.names = NA)

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

chimera.method <- "${chimera_method}"
multithread <- ${ncpus}

# load table and convert to matrix
seq.table <- read.csv("seq_table.tsv", sep="\\t")
rownames(seq.table) <- seq.table[,1]
seq.table <- seq.table[ -c(1) ]
seq.mat <- data.matrix(seq.table)
mode(seq.mat) <- "integer"

# chimera removal
seq.table.nochim <- removeBimeraDenovo(t(seq.mat), method=chimera.method, multithread=multithread, verbose=TRUE)

# Export sequences
uniquesToFasta(
   getUniques(seq.table.nochim),
   fout="unhashed_rep_seqs.fasta",
   ids=paste0("Seq", seq(length(getUniques(seq.table.nochim))))
)

# Export to biom
library(biomformat)
st.biom <- make_biom(t(seq.table.nochim))
write_biom(st.biom, "unhashed_otu_table.biom")

#!/usr/bin/env Rscript

library(mLDM)
library(caret)

otu_file <- "${otu_file}"
sample_metadata <- "${sample_metadata}"
Z_mean <- as.double("${Z_mean}")
max_iteration <- as.integer("${max_iteration}")
corr_file <- "${meta.id}_corr.tsv"

read_otu_data <- function(tablefile) {
    table <- read.table(tablefile, header=TRUE, check.names=FALSE, comment.char="", sep="\\t")
    table.rownames <- table[, 1]
    table <- table[, 2:ncol(table)]
    table.matrix <- data.matrix(table)
    rownames(table.matrix) <- table.rownames
    return(table.matrix)
}

read_sample_data <- function(tablefile) {
    table <- read.table(tablefile, header=TRUE, check.names=FALSE, comment.char="", sep="\\t")
    table.rownames <- table[, 1]
    table <- as.data.frame(table[, 2:ncol(table)])
    dmy <- dummyVars(" ~ .", data=table)
    table.frame <- data.frame(predict(dmy, newdata=table))
    table.matrix <- data.matrix(table.frame)
    rownames(table.matrix) <- table.rownames
    return(table.matrix)
}

otu <- read_otu_data(otu_file)
otu_t <- t(otu)
sample.md <- read_sample_data(sample_metadata) # Must be purely numeric or categorical metadata

mldmNetwork <- mLDM(X=otu_t, M=sample.md, Z_mean=Z_mean, max_iteration=max_iteration, verbose=TRUE)

otuNetwork <- mldmNetwork\$optimal[[9]]

rownames(otuNetwork) <- rownames(otu)
colnames(otuNetwork) <- rownames(otu)

# In case of incorrect convergence
otuNetwork[otuNetwork > 1] <- 1
otuNetwork[otuNetwork < -1] <- -1

write.table(otuNetwork, file=corr_file, quote=FALSE, col.names=NA, sep="\\t")

#!/usr/bin/env Rscript

suppressWarnings(library(dada2))

multithread <- ${ncpus}
maxEE <- ${max_ee}
truncQ <- ${trunc_q}
forward_trim_cmd <- "forward_trim.txt"
reverse_trim_cmd <- "reverse_trim.txt"

forward_untrimmed.reads <- list.files(".", pattern="_R1_001.fastq.gz\$", full.names=TRUE)
reverse_untrimmed.reads <- list.files(".", pattern="_R2_001.fastq.gz\$", full.names=TRUE)

  if(length(forward_untrimmed.reads) == 0) {
    errQuit("No input files with the expected filename format found.")
  }
  if(length(reverse_untrimmed.reads) == 0) {
    errQuit("No input files with the expected filename format found.")
  }

# read trim and filter commands
forward_trim.cmd <- read.csv(forward_trim_cmd, header=FALSE)
reverse_trim.cmd <- read.csv(reverse_trim_cmd, header=FALSE)
trimLeft <- c(forward_trim.cmd[1,2], reverse_trim.cmd[1,2])
truncLen <- c(forward_trim.cmd[2,2], reverse_trim.cmd[2,2])


# trim sequences
forward_trimmed.reads <- file.path("trimmed", basename(forward_untrimmed.reads))
reverse_trimmed.reads <- file.path("trimmed", basename(reverse_untrimmed.reads))
out <- suppressWarnings(
    filterAndTrim(
        forward_untrimmed.reads,
        forward_trimmed.reads,
        reverse_untrimmed.reads,
        reverse_trimmed.reads,
        truncLen=truncLen,
        trimLeft=trimLeft,
        maxEE=maxEE,
        truncQ=truncQ,
        rm.phix=TRUE,
        multithread=multithread
    )
)

# check trimmed reads
cat(ifelse(file.exists(forward_trimmed.reads), ".", "x"), sep="")
cat(ifelse(file.exists(reverse_trimmed.reads), ".", "x"), sep="")
trimmed.reads <- list.files("trimmed", pattern=".fastq.gz\$", full.names=TRUE)
cat("\n")
if(length(trimmed.reads) == 0) { # All reads were filtered out
  errQuit("No reads passed the filter (was truncLen longer than the read length?)", status=2)
}

manifest <- read.csv("MANIFEST", header=TRUE, check.names=FALSE)
manifest_trimmed <- manifest[manifest[, "filename"] %in% basename(trimmed.reads),]

write.csv(manifest_trimmed, "trimmed/MANIFEST", row.names=FALSE, quote=FALSE)

#!/usr/bin/env Rscript

library(COZINE)


otu_file <- "${otu_file}"
corr_file <- "${meta.id}_corr.tsv"
lambda.min.ratio <- as.double("${lambda_min_ratio}")

read_otu_data <- function(tablefile) {
  table <- read.table(tablefile, header = TRUE, check.names = FALSE, comment.char = "", sep = "\\t")
  table.rownames <- table[, 1]
  table <- table[, 2:ncol(table)]
  table.matrix <- data.matrix(table)
  rownames(table.matrix) <- table.rownames
  mode(table.matrix) <- "integer"
  return(table.matrix)
}

otu <- read_otu_data(otu_file)
otu_t <- t(otu)

# Calculate hurdle function and pcorr matrix
hf <- cozine(dat = otu_t, parallel = FALSE, lambda.min.ratio = lambda.min.ratio)
mat <- as.matrix(hf\$adjMat[[which.min(hf\$BIC_etc\$BIC)]])
# NOTE: This returns a non-symmetric matrix, hence we need to symmetrize it
otuNetwork <- (mat + t(mat)) / 2

write.table(otuNetwork, file = corr_file, quote = FALSE, col.names = NA, sep = "\\t")

#!/usr/bin/env Rscript

library(HARMONIES)

otu_file <- "${otu_file}"
corr_file <- "${meta.id}_corr.tsv"
iterations <- as.integer("${iterations}")
sparsity_cutoff <- as.double("${sparsity_cutoff}")

read_otu_data <- function(tablefile) {
  table <- read.table(tablefile, header = TRUE, check.names = FALSE, comment.char = "", sep = "\\t")
  table.rownames <- table[, 1]
  table <- table[, 2:ncol(table)]
  table.matrix <- data.matrix(table)
  rownames(table.matrix) <- table.rownames
  mode(table.matrix) <- "integer"
  return(table.matrix)
}

otu <- read_otu_data(otu_file)
otu_t <- t(otu)

inference.results <- HARMONIES(
  count.matrix = otu_t,
  phenotype = rep(0, nrow(otu_t)),
  N.mcmc = iterations,
  sparsity.cutoff = sparsity_cutoff,
  beta.stars = 0.05,
)

otuNetwork <- inference.results\$partial.corr
rownames(otuNetwork) <- rownames(otu)
colnames(otuNetwork) <- rownames(otu)

# In case of incorrect convergence
otuNetwork[otuNetwork > 1] <- 1
otuNetwork[otuNetwork < -1] <- -1

write.table(otuNetwork, file = corr_file, quote = FALSE, col.names = NA, sep = "\\t")

#!/usr/bin/env Rscript

library(propr)
library(parallel)

ncpus <- ${ncpus}

# cl <- makeCluster(ncpus)

read_otu <- function(otu_file) {
    otu <- read.table(otu_file, header=TRUE, comment.char="", check.names=FALSE, sep="\\t")
    rownames(otu) <- otu[, 1]
    otu <- otu[, 2:ncol(otu)]
    return(otu)
}

apply_propr <- function(otu_file, bootstrap=TRUE) {
    otu <- read_otu(otu_file)
    if(bootstrap) {
        corr_file <- gsub("_otu.boot", "_corr.boot", otu_file)
    } else {
        corr_file <- paste0("${meta.id}", "_corr.tsv")
    }
    pr <- propr(t(otu), metric = "rho", ivar = "clr")
    mat <- pr@matrix
    matdims <- rep(list(rownames(otu)), 2)
    dimnames(mat) <- matdims
    if(otu_file == corr_file) stop("Correlation file and OTU file names are the same")
    write.table(mat, file=corr_file, sep="\\t", quote=FALSE, col.names=NA)
    return(corr_file)
}

apply_propr("${otu_file}", bootstrap=FALSE)

bootstrap_files = list.files(pattern="*_otu.boot")
results <- mclapply(bootstrap_files, apply_propr, mc.cores = ncpus)

#!/usr/bin/env Rscript

library(SpiecEasi)
library(Matrix)

otu_file <- "${otu_file}"
method <- "${method}"
rep.num <- ${nreps}
ncpus <- ${ncpus}
nlambda <- ${nlambda}
lambda.min.ratio <- ${lambda_min_ratio}
corr_file <- "${otu_file.baseName.split('_otu')[0]}_corr.tsv"

# NOTE: The data does not have to be normalized
# Read in the OTU table
read_otu <- function(otufile) {
    otu <- read.table(otufile, header=TRUE, comment.char="", sep="\\t")
    rownames(otu) <- otu[, 1]
    otu <- otu[, 2:ncol(otu)]
    return(otu)
}

# NOTE: You have to transpose the otu_data
# Calculate correlations using SpiecEasi
run_spieceasi <- function(otu_data, method="mb", rep.num=50, ncores=4, nlambda=20, lambda.min.ratio=1e-2) {
    otu_ids <- rownames(otu_data)
    otu.spieceasi <- spiec.easi(
        t(otu_data),
        method=method,
        lambda.min.ratio=lambda.min.ratio,
        nlambda=nlambda,
        pulsar.params=list(rep.num=rep.num, ncores=ncores)
    )
    if(method == "mb") {
        sebeta <- symBeta(getOptBeta(otu.spieceasi), mode="maxabs")
        mat <- as.matrix(sebeta)
    } else if (method == "glasso") {
        secor <- cov2cor(getOptCov(otu.spieceasi))
        mat <- as.matrix(secor*getRefit(otu.spieceasi))
    }
    matdims <- rep(list(otu_ids), 2)
    dimnames(mat) <- matdims
    return(mat)
}


# Actual script
otu_data <- read_otu(otu_file)
spieceasi.corr <- run_spieceasi(
    otu_data,
    method=method,
    rep.num=rep.num,
    ncores=ncpus,
    nlambda=nlambda,
    lambda.min.ratio=lambda.min.ratio
)
write.table(spieceasi.corr, file=corr_file, sep="\\t", quote=FALSE, col.names=NA)

#!/usr/bin/env Rscript

library(propr)

otu_file <- "${otu_file}"
corr_file <- "${otu_file.baseName.split('_otu')[0]}_corr.tsv"

read_otu <- function(otufile) {
    otu <- read.table(otufile, header=TRUE, comment.char="", sep="\\t")
    rownames(otu) <- otu[, 1]
    otu <- otu[, 2:ncol(otu)]
    return(otu)
}


otu <- read_otu(otu_file)

pr <- propr(t(otu), metric = "rho", ivar = "clr")
mat <- pr@matrix
matdims <- rep(list(rownames(otu)), 2)
dimnames(mat) <- matdims

write.table(mat, file=corr_file, sep="\\t", quote=FALSE, col.names=NA)

#!/usr/bin/env bash

mkdir bootstraps

fastspar_bootstrap \
    --otu_table ${otu_file} \
    --number ${bootstraps} \
    --prefix bootstraps/${meta.id} \
    --threads ${ncpus}

for f in bootstraps/*.tsv; do
    mv -- "\$f" "\${f%.tsv}_otu.boot"
done

#!/usr/bin/env bash

set -e

source activate micone-netcomi

R -e 'devtools::install_github("stefpeschel/NetCoMi", dependencies = TRUE, repos = c("https://cloud.r-project.org/", BiocManager::repositories())); NetCoMi::installNetCoMiPacks()'

#!/usr/bin/env bash

pick_closed_reference_otus.py \
  -i ${fasta_file} \
  ${parallel_option} \
  -r ${reference_sequences} \
  -p ${parameters} \
  --suppress_taxonomy_assignment \
  -f -o \$PWD

pick_rep_set.py \
  -i uclust_ref_picked_otus/${meta.id}_otus.txt \
  -f ${fasta_file} \
  -o rep_seqs.fasta

mv otu_table.biom unhashed_otu_table.biom
mv rep_seqs.fasta unhashed_rep_seqs.fasta

#!/usr/bin/env bash

set -e

# blast
qiime  feature-classifier classify-consensus-blast \
    --i-query ${repseq_artifact} \
    --i-reference-reads ${reference_sequences} \
    --i-reference-taxonomy ${tax_map} \
    --p-maxaccepts ${max_accepts} \
    --p-perc-identity ${perc_identity} \
    --p-evalue ${evalue} \
    --p-min-consensus ${min_consensus} \
    --o-classification taxonomy.qza

# export the taxonomy assignment
qiime tools export \
    --input-path taxonomy.qza \
    --output-path taxonomy

cp taxonomy/taxonomy.tsv taxonomy.tsv

#!/usr/bin/env #!/bin/bash

set -e

MAIN_VERSION="1.5"
VERSION="julia-1.5.3"
FNAME="$MAIN_VERSION/$VERSION-linux-x86_64.tar.gz"

URL="https://julialang-s3.julialang.org/bin/linux/x64/$FNAME"
FOLDER=/tmp/$(cat /dev/urandom | tr -dc 'a-zA-Z0-9' | fold -w 16 | head -n 1)

mkdir "$FOLDER"
wget -O "$FOLDER/julia.tar.gz" --quiet "$URL"
tar xzf "$FOLDER/julia.tar.gz" -C "$FOLDER"

source activate micone-flashweave

cp -r "$FOLDER/$VERSION" "$CONDA_PREFIX/"
ln -s "$CONDA_PREFIX/$VERSION/bin/julia" "$CONDA_PREFIX/bin/julia"

source activate micone-flashweave
julia -e 'import Pkg; Pkg.add("FlashWeave"); Pkg.add("CSV"); Pkg.add("DataFrames"); using FlashWeave;'

#!/usr/bin/env bash

fastspar --iterations $iterations --yes \
    --otu_table $otu_file \
    --correlation ${otu_file.baseName.split("_otu")[0]}_corr.tsv \
    --covariance ${otu_file.baseName.split("_otu")[0]}_cov.tsv \
    --threads ${ncpus}

#!/usr/bin/env bash

set -e

export TMPDIR=\$PWD

# import reads
qiime tools import \
    --type 'FeatureData[Sequence]' \
    --input-path ${rep_seqs} \
    --output-path rep_seqs.qza

# assign taxonomy to the rep_seqs
qiime feature-classifier classify-sklearn \
    --i-classifier ${classifier} \
    --i-reads rep_seqs.qza \
    --p-n-jobs ${ncpus} \
    --p-confidence ${confidence} \
    --o-classification taxonomy.qza

# export the taxonomy assignment
qiime tools export \
    --input-path taxonomy.qza \
    --output-path taxonomy

cp taxonomy/taxonomy.tsv taxonomy.tsv

#!/usr/bin/env bash

mkdir corr_bootstraps
mv *_boot_*_corr.boot corr_bootstraps

BOOTSTRAPS=\$(ls -1 corr_bootstraps | wc -l)

fastspar_pvalues --otu_table $otu_file \
    --correlation $corr_file \
    --prefix corr_bootstraps/${level}_boot \
    --permutations \$BOOTSTRAPS \
    --outfile ${level}_pval.tsv \
    --threads ${ncpus}

#!/usr/bin/env bash

qiime demux emp-single \
    --i-seqs ${sequence_artifact} \
    --m-barcodes-file ${mapping_file} \
    --m-barcodes-column ${barcode_column} \
    ${rcb} \
    ${rcmb} \
    --o-per-sample-sequences ${meta.id}_demux.qza \
    --o-error-correction-details ${meta.id}_error.qza

#!/usr/bin/env bash

set -e

# Import biom file
qiime tools import \
    --input-path ${otutable_file} \
    --type 'FeatureTable[Frequency]' \
    --input-format BIOMV210Format \
    --output-path otu_table.qza

# Import representative sequences
qiime tools import \
    --input-path ${repseqs_file} \
    --type 'FeatureData[Sequence]' \
    --output-path rep_seqs.qza

#!/usr/bin/env bash

set -e

# Export otu table
qiime tools export \
    --input-path ${otutable_nonchimeric} \
    --output-path otu_table

# Export representative sequences
qiime tools export \
    --input-path ${repseqs_nonchimeric} \
    --output-path rep_seqs

mv otu_table/feature-table.biom otu_table.biom
mv rep_seqs/dna-sequences.fasta rep_seqs.fasta

#!/usr/bin/env bash

mkdir corr_bootstraps
mv *.boot corr_bootstraps

BOOTSTRAPS=\$(ls -1 corr_bootstraps | wc -l)

fastspar_pvalues --otu_table ${otu_file} \
    --correlation ${corr_file} \
    --prefix corr_bootstraps/ \
    --permutations \$BOOTSTRAPS \
    --outfile ${meta.id}_pval.tsv \
    --threads ${ncpus}

if [[ ${slim} = "true" ]]; then
    for FILE in corr_bootstraps/*; do
        rm \$(readlink -f \$FILE)
        rm \$FILE
    done
fi

#!/usr/bin/env bash

set -e

source activate micone-harmonies

R -e 'install.packages(c("mvnfast", "networkD3"), repo="https://mirror.las.iastate.edu/CRAN/")'
R -e 'library(devtools); install_github("shuangj00/HARMONIES", subdir = "pkg" )'

#!/usr/bin/env bash

set -e

source activate micone-mldm

R -e 'install.packages(c("lbfgs", "RcppEigen"), repos="http://archive.linux.duke.edu/cran/")'
R -e 'install.packages("https://cran.r-project.org/src/contrib/Archive/QUIC/QUIC_1.1.1.tar.gz", repos=NULL, type="source")'
R -e 'install.packages("https://github.com/tinglab/mLDM/raw/master/mLDM_1.1.tar.gz", repos=NULL, type="source")'

#!/usr/bin/env bash

fastspar --iterations ${iterations} --yes \
    --otu_table ${otu_file} \
    --correlation ${meta.id}_corr.tsv \
    --covariance ${meta.id}_cov.tsv \
    --threads ${ncpus}

function do_fastspar {
    fastspar --iterations ${iterations} --yes \
        --otu_table \$1 \
        --correlation \${1%_otu.boot}_corr.boot \
        --covariance \${1%_otu.boot}_cov.boot \
        --threads 1
    rm -f \${1%_otu.boot}_cov.boot
}

export -f do_fastspar

find . -name "*_otu.boot" | parallel -j ${ncpus} do_fastspar

#!/usr/bin/env bash

mkdir sequence_folder
mv ${sequence_files} sequence_folder
mv ${manifest_file} sequence_folder
mv ${sequence_metadata} sequence_folder

qiime tools import \
    --input-path sequence_folder \
    --output-path seq_artifact.qza \
    --type "SampleData[PairedEndSequencesWithQuality]"

qiime vsearch join-pairs \
    --i-demultiplexed-seqs seq_artifact.qza \
    --o-joined-sequences joined_artifact.qza

qiime tools export \
    --input-path joined_artifact.qza \
    --output-path joined_reads

#!/usr/bin/env bash

mkdir "${meta.id}"
cp "${manifest_file}" "${meta.id}"/
cp "${sequence_metadata}" "${meta.id}"/
cp *.fastq.gz "${meta.id}"/

qiime tools import \
    --input-path "${meta.id}" \
    --output-path "${meta.id}_sequences.qza" \
    --type "SampleData[PairedEndSequencesWithQuality]"

#!/usr/bin/env bash

pick_open_reference_otus.py \
    -i ${fasta_file} \
    -m ${picking_method} \
    -r ${reference_sequences} \
    -p ${parameters} \
    ${parallel_option} \
    --suppress_taxonomy_assignment \
    --suppress_align_and_tree \
    -f -o \$PWD

mv rep_set.fna unhashed_rep_seqs.fasta
mv otu_table_mc2.biom unhashed_otu_table.biom

#!/usr/bin/env bash

qiime tools export \
    --input-path "${demux_artifact}" \
    --output-path demux_seqs

if [[ "${sample_filter}" ]]; then
    cd demux_seqs || exit
    ls -1 | grep -Ev "(MANIFEST|metadata.yml|${sample_filter})" | xargs rm -f
    mv MANIFEST MANIFEST_OLD
    grep -E "(sample-id|${sample_filter})" MANIFEST_OLD >MANIFEST
    rm MANIFEST_OLD
fi

#!/usr/bin/env bash

set -e

# import reference sequences
# NOTE: qiime feature-classifier extract-reads must already be performed on the reference sequences
qiime tools import \
    --type 'FeatureData[Sequence]' \
    --input-path ${params.naive_bayes.reference_sequences} \
    --output-path reference_sequences.qza

# import sequence taxonomy mapping
qiime tools import \
    --type 'FeatureData[Taxonomy]' \
    --input-format HeaderlessTSVTaxonomyFormat \
    --input-path ${params.naive_bayes.tax_map} \
    --output-path tax_map.qza

qiime feature-classifier fit-classifier-naive-bayes \
    --i-reference-reads reference_sequences.qza \
    --i-reference-taxonomy tax_map.qza \
    --o-classifier classifier.qza

#!/usr/bin/env bash

set -e

qiime vsearch uchime-denovo \
  --i-table ${otutable_artifact} \
  --i-sequences ${repseqs_artifact} \
  --output-dir output

qiime feature-table filter-features \
  --i-table ${otutable_artifact} \
  --m-metadata-file output/nonchimeras.qza \
  --o-filtered-table otu_table_nonchimeric.qza

qiime feature-table filter-seqs \
  --i-data ${repseqs_artifact} \
  --m-metadata-file output/nonchimeras.qza \
  --o-filtered-data rep_seqs_nonchimeric.qza

#!/usr/bin/env bash

set -e

mkdir sequence_folder
mv ${sequence_files} sequence_folder
mv ${manifest_file} sequence_folder
mv ${sequence_metadata} sequence_folder

qiime tools import \
    --input-path sequence_folder \
    --output-path seq_artifact.qza \
    --type "${seq_type}"

qiime deblur denoise-16S \
    --i-demultiplexed-seqs seq_artifact.qza \
    --p-hashed-feature-ids \
    --p-trim-length -1 \
    --p-min-reads ${min_reads} \
    --p-min-size ${min_size} \
    --p-jobs-to-start ${ncpus} \
    --o-representative-sequences rep-seqs.qza \
    --o-table table.qza \
    --o-stats stats.qza

qiime tools export \
    --input-path rep-seqs.qza \
    --output-path rep_seqs

qiime tools export \
    --input-path table.qza \
    --output-path table

mv table/feature-table.biom ${meta.id}-${meta.run}_unhashed_otu_table.biom
mv rep_seqs/dna-sequences.fasta ${meta.id}-${meta.run}_unhashed_rep_seqs.fasta
mv ${samplemetadata_files} ${meta.id}-${meta.run}_sample_metadata.tsv

#!/usr/bin/env bash

set -e

# import reference sequences
qiime tools import \
    --type 'FeatureData[Sequence]' \
    --input-path ${params.blast.reference_sequences} \
    --output-path reference_sequences.qza

# import sequence taxonomy mapping
qiime tools import \
    --type 'FeatureData[Taxonomy]' \
    --input-format HeaderlessTSVTaxonomyFormat \
    --input-path ${params.blast.tax_map} \
    --output-path tax_map.qza

#!/usr/bin/env bash

mkdir ${meta.id}
cp ${forward_file} ${meta.id}/forward.fastq.gz
cp ${reverse_file} ${meta.id}/reverse.fastq.gz
cp ${barcode_file} ${meta.id}/barcodes.fastq.gz

qiime tools import \
    --type EMPPairedEndSequences \
    --input-path ${meta.id} \
    --output-path ${meta.id}_sequences.qza

#!/usr/bin/env bash

qiime tools import \
  --input-path ${fasta_file} \
  --output-path seqs.qza \
  --type 'SampleData[Sequences]'

qiime vsearch dereplicate-sequences \
  --i-sequences seqs.qza \
  --o-dereplicated-table table.qza \
  --o-dereplicated-sequences rep-seqs.qza

qiime vsearch cluster-features-closed-reference \
  --i-table table.qza \
  --i-sequences rep-seqs.qza \
  --i-reference-sequences ${reference_sequences} \
  --p-perc-identity ${percent_identity} \
  --p-strand ${strand} \
  --p-threads ${ncpus} \
  --o-clustered-table table-cr.qza \
  --o-clustered-sequences rep-seqs-cr.qza \
  --o-unmatched-sequences unmatched-cr.qza

qiime tools export \
    --input-path table-cr.qza \
    --output-path table

qiime tools export \
    --input-path rep-seqs-cr.qza \
    --output-path rep_seqs

mv table/feature-table.biom ${meta.id}-${meta.run}_unhashed_otu_table.biom
mv rep_seqs/dna-sequences.fasta ${meta.id}-${meta.run}_unhashed_rep_seqs.fasta
mv ${samplemetadata_files} ${meta.id}-${meta.run}_sample_metadata.tsv

#!/usr/bin/env bash

join_paired_ends.py \
    -f ${sequence_files[0]} \
    -r ${sequence_files[1]} \
    -b ${barcode_file} \
    --min_overlap ${min_overlap} \
    --perc_max_diff ${perc_max_diff} \
    --output_dir joined_reads \

gzip joined_reads/fastqjoin.join.fastq
mv joined_reads/fastqjoin.join.fastq.gz joined_reads/${sequence_files[0].baseName.split('_forward')[0]}_reads.fastq.gz

gzip joined_reads/fastqjoin.join_barcodes.fastq
mv joined_reads/fastqjoin.join_barcodes.fastq.gz joined_reads/${barcode_file.getSimpleName()}.fastq.gz

#!/usr/bin/env bash

pick_de_novo_otus.py \
  -i ${fasta_file} \
  ${parallel_option} \
  -p ${parameters} \
  -f -o \$PWD

mv rep_set/${meta.id}_rep_set.fasta rep_seqs.fasta

mv otu_table.biom unhashed_otu_table.biom
mv rep_seqs.fasta unhashed_rep_seqs.fasta

#!/usr/bin/env bash

mkdir ${id}
cp ${sequence_file} ${id}/sequences.fastq.gz
cp ${barcode_file} ${id}/barcodes.fastq.gz

qiime tools import \
    --type EMPSingleEndSequences \
    --input-path ${id} \
    --output-path ${id}_sequences.qza
